; Beginning of something.
;2011 May 18 	JDM

function champreader,filename

;TIME
;FLUX
;FTOFFSET
;REFOFFSET
;FTPHI
;FTNUM
;FRAME
;BCSTATE
;DELAY ?


if keyword_set(filename) eq 0 then filename=dialog_pickfile()


;struct0={dither:1L,  frame:1, channel:1,  rtime:double(1), lock:1,$
;   offset:1.0, phase:1.0, num:1.0, opd:1.0, flux:1.0, gdt_opd:1.0, gdt_num:1.0}

a=mrdfits(filename,0,head0)
frameperreset=sxpar(head0,'FRMPRST')
ncombos=sxpar(head0,'NCOMBOS')

nframes=2*frameperreset

flux_str=mrdfits(filename,'FLUX')
opd_str=mrdfits(filename,'CHANNELOPD')
nvals=n_elements(flux_str)
ndithers=nvals/nframes/2

data=fltarr(nframes,ncombos,ndithers)
phases=fltarr(nframes,ncombos/2,ndithers)
ftoffsets=fltarr(nframes,ncombos/2,ndithers)
opd=fltarr(nframes,ncombos,ndithers)

for j=0,5 do begin  
  if j eq 0 then allvals=flux_str.combo_1
  if j eq 1 then allvals=flux_str.combo_2
  if j eq 2 then allvals=flux_str.combo_3
  if j eq 3 then allvals=flux_str.combo_4
  if j eq 4 then allvals=flux_str.combo_5
  if j eq 5 then allvals=flux_str.combo_6

for i=0l,ndithers-1l do begin
  i0=i*long(nframes)*2l
  i1=i0+nframes-1
  data[*,2*j,i]=allvals[i0:i1]
  i0=i0+nframes
  i1=i0+nframes-1
  data[*,2*j+1,i]=allvals[i0:i1]
endfor
endfor
;-----
for j=0,5 do begin 
  if j eq 0 then allvals=opd_str.combo_1
  if j eq 1 then allvals=opd_str.combo_2
  if j eq 2 then allvals=opd_str.combo_3
  if j eq 3 then allvals=opd_str.combo_4
  if j eq 4 then allvals=opd_str.combo_5
  if j eq 5 then allvals=opd_str.combo_6

for i=0l,ndithers-1l do begin
  i0=i*long(nframes)*2l
  i1=i0+nframes-1
  opd[*,2*j,i]=allvals[i0:i1]
  i0=i0+nframes
  i1=i0+nframes-1
  opd[*,2*j+1,i]=allvals[i0:i1]
endfor
endfor
;-----

 ftphi_str=mrdfits(filename,'FTPHI')
for j=0,5 do begin
  if j eq 0 then allvals=ftphi_str.combo_1
  if j eq 1 then allvals=ftphi_str.combo_2
  if j eq 2 then allvals=ftphi_str.combo_3
  if j eq 3 then allvals=ftphi_str.combo_4
  if j eq 4 then allvals=ftphi_str.combo_5
  if j eq 5 then allvals=ftphi_str.combo_6

for i=0l,ndithers-1l do begin
  i0=i*long(nframes)
  i1=i0+nframes-1
  phases[*,j,i]=allvals[i0:i1]
endfor
endfor
;-------
;----- 

 ftoffsets_str=mrdfits(filename,'FTOFFSET')
for j=0,5 do begin
  if j eq 0 then allvals=ftoffsets_str.combo_1
  if j eq 1 then allvals=ftoffsets_str.combo_2
  if j eq 2 then allvals=ftoffsets_str.combo_3
  if j eq 3 then allvals=ftoffsets_str.combo_4
  if j eq 4 then allvals=ftoffsets_str.combo_5
  if j eq 5 then allvals=ftoffsets_str.combo_6

for i=0l,ndithers-1l do begin
  i0=i*long(nframes)
  i1=i0+nframes-1
  ftoffsets[*,j,i]=allvals[i0:i1]
endfor
endfor
;-------


  
struct={data:data, phases:phases,nframes:nframes,ndithers:ndithers, ncombos:ncombos,opd:opd,ftoffsets:ftoffsets}

return,struct
end
