#include <complex.h>

#define PI  3.14159265
#define SQR(a)        ((a) * (a))
#define MIN(a, b)     (((a) < (b)) ? (a) : (b))
#define MAX(a, b)     (((a) > (b)) ? (a) : (b))
#define SUM(a, b)     (a + b)
#define SUMSQR(a, b)  ( ((a)*(a)) + ((b)*(b)) )
#define ROUND(a)      ((a)>0 ? (int)((a)+0.5) : -(int)(0.5-(a)))

#define ARANGE(a, b)        for ( i = 0; i < b; i++) a[i] = i
#define MAX_ARRAY(a, b, c)  c=a[0]; for ( i = 1; i < b; i++) if ( a[i] > a[i-1] ) c=a[i]
#define MIN_ARRAY(a, b, c)  c=a[0]; for ( i = 1; i < b; i++) if ( a[i] < a[i-1] ) c=a[i]
#define TOTAL(a, b, c)      c=0; for ( i = 0; i < b; i++) c += a[i]


void solve_3se(double *a, double *b, double *c, double *y, double *x);
void champ_bs4 (double *w, double *OPD0, double *OPD1, double *DL0);
void champ_bs6 (double *w, double *OPD0, double *OPD1, double *DL0);
void bubbleSort(float *a, unsigned int n);
float sinc(float x);
float max(float* vector, int n);
void dewarp(float *bias_matrix, int indx, float *biased_n, float *biased_x, float *biased_y, double *debiased_n, double *debiased_x, double *debiased_y);
